Subject: Re: bug#7689: Fwd: Due for a new release?

From: Stefano Lattarini <[email-masked]>
Date: Thu, 23 Dec 2010 12:05:09 +0100

On Thursday 23 December 2010, Philip Prindeville wrote:
> On 12/22/10 4:36 PM, Stefano Lattarini wrote:
> > Well, since one of the primary goals of Automake is generating *portable*
> > Makefiles (and believe me it goes through considerable pain to do so), its
> > behaviour is perfectly rational in this regard.
> >
> > That said, I think that having more granular warnings about make-only
> > portability issues might make sense; so that a developer interested in
> > supporting only GNU make could do something like:
> >
> >    AUTOMAKE_OPTIONS([-Wall -Wno-make-portability])
> >
> > and then safely use GNU extensions in his Makefile.am, while preserving
> > all the other portability warnings provided by Automake.
> >
> > In light of this, I'm re-opening and re-titling this bug (with severity
> > "whishlist" this time).
> >
> > Thanks,
> >     Stefano
> 
> Changing the default to do this would probably better satisfy the Principle
> of Least Astonishment. :-)
> 
I disagree.  When passing `-Wall', you are asking automake to report to
you *all* the warnings about *all* the problems it's able to find.  And
automake does so.  This is Least Astonishment for me.  And since automake
is all about portability, it's natural (even required I'd say) that it is
able to find out and report possible portability problems.

If, after having enabled -Wall, you decide you're not really interested
in a particular class of warnings, you can tell automake not to report
the warnings in that class:

  AUTOMAKE_OPTIONS = -Wall -Wno-portability

This is a consistent and good policy IMO; the only blemish is that it's
currently somewhat lacking in granularity for the warning categories...
which is what this bug report is about now ;-)

Regards,
   Stefano